=== modified file 'Makefile'
--- Makefile	2009-10-25 19:16:56 +0000
+++ Makefile	2009-05-23 05:59:52 +0000
@@ -9,19 +9,14 @@
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
-LINK_FORTIFY_LD=-z relro -z now
-LINK_FORTIFY=
-ifndef BROKEN_PIE
-FORTIFY += -fPIE
-LINK_FORTIFY_LD += -fPIE
-LINK_FORTIFY += -pie
-endif
+FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC -fPIE
+LINK_FORTIFY_LD=-z relro -fPIE
+LINK_FORTIFY=-pie
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.14
+version=1.0.11
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2009-10-25 19:16:56 +0000
+++ NEWS	2009-05-23 05:59:52 +0000
@@ -1,31 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.0.14 (2009-10-25)
-Enable building without -pie and -fPIE if BROKEN_PIE is set.
-
-Version 1.0.13 (2009-10-22)
-* Client
-** Security bug fix: If Mandos server is also installed, do not copy
-   its config files (with encrypted passwords) into the initrd.img-*
-   files.
-
-Version 1.0.12 (2009-09-17)
-* Client
-** Bug fix: Allow network interface renaming by "udev" by taking down
-   the network interface after using it.
-** Bug fix: User-supplied plugins are now installed correctly.
-** Bug fix: If usplash was used but the password was instead provided
-   by the Mandos server, the usplash daemon used to ignore the first
-   command passed to it.  This has been fixed.
-** Bug fix: Make the "--userid" and "--groupid" options in
-   "plugin-runner.conf" work.
-* Server
-** Bug fix: Fix the LSB header in the init.d script to make dependency
-   based booting work.
-** A client receiving its password now also counts as if a checker was
-   run successfully (i.e. the timeout timer is reset).
-
 Version 1.0.11 (2009-05-23)
 * Client
 ** Bug fix: Use "pkg-config" instead of old "libgnutls-config".

=== modified file 'TODO'
--- TODO	2009-09-17 11:47:22 +0000
+++ TODO	2009-09-17 01:21:27 +0000
@@ -45,6 +45,8 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Date+time on console log messages	:BUGS:
    Is this the default?
+** TODO Split IPv6_TCPServer into a generic and Mandos-specific class
+** TODO move handle_ipc out of IPv6_TCPServer
 ** TODO DBusServiceObjectUsingSuper
 ** Global enable/disable flag
 ** By-client countdown on secrets given
@@ -61,9 +63,10 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 
-* mandos-monitor
+* mandos-name
 ** D-Bus mail loop w/ signal receiver
-** Snack/Newt client data displayer
+** Urwid/Newt client data displayer
+*** Urwid scaffolding
 *** Client Widgets
 *** Properties popup
 

=== modified file 'common.ent'
--- common.ent	2009-10-25 19:16:56 +0000
+++ common.ent	2009-05-23 05:59:52 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.0.14">
+<!ENTITY version "1.0.11">

=== modified file 'debian/changelog'
--- debian/changelog	2009-10-25 19:16:56 +0000
+++ debian/changelog	2009-05-23 05:59:52 +0000
@@ -1,34 +1,3 @@
-mandos (1.0.14-1) unstable; urgency=low (HIGH on mips and mipsel)
-
-  * New upstream release.
-  * debian/rules: Build with BROKEN_PIE set on mips and mipsel
-    architectures - fixes FTBFS there.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sun, 25 Oct 2009 20:10:09 +0100
-
-mandos (1.0.13-1) unstable; urgency=high
-
-  * New upstream release.
-  * Do not copy unnecessary files to initrd (Closes: #551907)
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 22 Oct 2009 00:53:21 +0200
-
-mandos (1.0.12-1) unstable; urgency=low
-
-  * New upstream release.
-  * init.d-mandos: Correct dependencies (Closes: #546928)
-  * debian/control (Standards-Version): Changed to "3.8.3".
-  * debian/mandos-client.README.Debian: Improved wording and formatting.
-    Updated location of nfsroot.txt.
-  * debian/mandos.README.Debian: Improved wording and formatting.
-  * debian/mandos-client.postinst (configure): Don't look for user and
-    group with the old name if upgrading from a new enough version.
-  * debian/mandos.postinst (configure): - '' -
-  * debian/mandos-client.README.Debian: Added text about non-usability of
-    pseudo-network interfaces.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 17 Sep 2009 15:03:59 +0200
-
 mandos (1.0.11-1) unstable; urgency=low
 
   * debian/control (Standards-Version): Changed to "3.8.1".

=== modified file 'debian/rules'
--- debian/rules	2009-10-25 19:06:56 +0000
+++ debian/rules	2009-01-18 00:18:50 +0000
@@ -15,15 +15,6 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
-ifneq (,$(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:))
-  BROKEN_PIE := yes
-  export BROKEN_PIE
-endif
-ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:))
-  BROKEN_PIE := yes
-  export BROKEN_PIE
-endif
-
 configure: configure-stamp
 configure-stamp:
 	dh_testdir

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2009-10-21 22:48:02 +0000
+++ initramfs-tools-hook	2009-09-07 23:48:17 +0000
@@ -114,7 +114,7 @@
 fi
 
 # Config files
-for file in /etc/mandos/plugin-runner.conf; do
+for file in /etc/mandos/*; do
     if [ -d "$file" ]; then
 	continue
     fi

=== modified file 'mandos'
--- mandos	2010-08-16 04:30:16 +0000
+++ mandos	2009-08-30 03:10:29 +0000
@@ -77,7 +77,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.0.14"
+version = "1.0.11"
 
 logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
@@ -1196,8 +1196,8 @@
                       help=u"Directory to search for configuration"
                       u" files")
     parser.add_option("--no-dbus", action=u"store_false",
-                      dest=u"use_dbus",
-                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
+                      dest=u"use_dbus", help=u"Do not provide D-Bus"
+                      u" system bus interface")
     parser.add_option("--no-ipv6", action=u"store_false",
                       dest=u"use_ipv6", help=u"Do not use IPv6")
     options = parser.parse_args()[0]
@@ -1255,7 +1255,6 @@
     # For convenience
     debug = server_settings[u"debug"]
     use_dbus = server_settings[u"use_dbus"]
-    use_dbus = False            # XXX: Not done yet
     use_ipv6 = server_settings[u"use_ipv6"]
     
     if not debug:
@@ -1284,8 +1283,7 @@
     tcp_server = MandosServer((server_settings[u"address"],
                                server_settings[u"port"]),
                               ClientHandler,
-                              interface=(server_settings[u"interface"]
-                                         or None),
+                              interface=server_settings[u"interface"],
                               use_ipv6=use_ipv6,
                               gnutls_priority=
                               server_settings[u"priority"],

=== modified file 'mandos-ctl'
--- mandos-ctl	2009-10-25 19:16:56 +0000
+++ mandos-ctl	2009-08-30 03:10:29 +0000
@@ -31,7 +31,7 @@
 server_path = '/'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.0.14"
+version = "1.0.11"
 bus = dbus.SystemBus()
 mandos_dbus_objc = bus.get_object(busname, server_path)
 mandos_serv = dbus.Interface(mandos_dbus_objc,

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-10-25 19:16:56 +0000
+++ mandos-keygen	2009-05-23 05:59:52 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.14"
+VERSION="1.0.11"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-10-25 19:16:56 +0000
+++ mandos.lsm	2009-05-23 05:59:52 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.14
-Entered-date:	2009-10-25
+Version:	1.0.11
+Entered-date:	2009-05-23
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      103K mandos_1.0.14.orig.tar.gz
+	      99K mandos_1.0.11.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		103K mandos_1.0.14.orig.tar.gz
+		99K mandos_1.0.11.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2009-09-17 11:47:22 +0000
+++ mandos.xml	2009-09-17 01:21:27 +0000
@@ -86,6 +86,8 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
+      <arg><option>--no-dbus</option></arg>
+      <sbr/>
       <arg><option>--no-ipv6</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -233,6 +235,16 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--no-dbus</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
+	  <para>
+	    See also <xref linkend="dbus_interface"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--no-ipv6</option></term>
 	<listitem>
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
@@ -336,6 +348,16 @@
     </para>
   </refsect1>
   
+  <refsect1 id="dbus_interface">
+    <title>D-BUS INTERFACE</title>
+    <para>
+      The server will by default provide a D-Bus system bus interface.
+      This interface will only be accessible by the root user or a
+      Mandos-specific user, if such a user exists.
+      <!-- XXX -->
+    </para>
+  </refsect1>
+  
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-08-11 20:06:18 +0000
+++ plugins.d/mandos-client.c	2009-09-16 23:28:39 +0000
@@ -44,7 +44,7 @@
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
-				   srand(), strtof(), abort() */
+				   srand(), strtof() */
 #include <stdbool.h>		/* bool, false, true */
 #include <string.h>		/* memset(), strcmp(), strlen(),
 				   strerror(), asprintf(), strcpy() */
@@ -72,7 +72,7 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause() */
+				   setgid() */
 #include <arpa/inet.h>		/* inet_pton(), htons */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
@@ -125,8 +125,6 @@
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-static const char sys_class_net[] = "/sys/class/net";
-char *connect_to = NULL;
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
@@ -144,9 +142,6 @@
 		      .dh_bits = 1024, .priority = "SECURE256"
 		      ":!CTYPE-X.509:+CTYPE-OPENPGP" };
 
-sig_atomic_t quit_now = 0;
-int signal_received = 0;
-
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
@@ -481,9 +476,6 @@
   /* GnuTLS session creation */
   do {
     ret = gnutls_init(session, GNUTLS_SERVER);
-    if(quit_now){
-      return -1;
-    }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
@@ -494,10 +486,6 @@
     const char *err;
     do {
       ret = gnutls_priority_set_direct(*session, mc.priority, &err);
-      if(quit_now){
-	gnutls_deinit(*session);
-	return -1;
-      }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
       fprintf(stderr, "Syntax error at: %s\n", err);
@@ -511,10 +499,6 @@
   do {
     ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
 				 mc.cred);
-    if(quit_now){
-      gnutls_deinit(*session);
-      return -1;
-    }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
@@ -535,6 +519,9 @@
 static void empty_log(__attribute__((unused)) AvahiLogLevel level,
 		      __attribute__((unused)) const char *txt){}
 
+sig_atomic_t quit_now = 0;
+int signal_received = 0;
+
 /* Called when a Mandos server is found */
 static int start_mandos_communication(const char *ip, uint16_t port,
 				      AvahiIfIndex if_index,
@@ -546,11 +533,11 @@
     struct sockaddr_in6 in6;
   } to;
   char *buffer = NULL;
-  char *decrypted_buffer = NULL;
+  char *decrypted_buffer;
   size_t buffer_length = 0;
   size_t buffer_capacity = 0;
   size_t written;
-  int retval = -1;
+  int retval = 0;
   gnutls_session_t session;
   int pf;			/* Protocol family */
   
@@ -583,6 +570,7 @@
   tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
     perror("socket");
+    retval = -1;
     goto mandos_end;
   }
   
@@ -600,10 +588,12 @@
   }
   if(ret < 0 ){
     perror("inet_pton");
+    retval = -1;
     goto mandos_end;
   }
   if(ret == 0){
     fprintf(stderr, "Bad address: %s\n", ip);
+    retval = -1;
     goto mandos_end;
   }
   if(af == AF_INET6){
@@ -617,6 +607,7 @@
       if(if_index == AVAHI_IF_UNSPEC){
 	fprintf(stderr, "An IPv6 link-local address is incomplete"
 		" without a network interface\n");
+	retval = -1;
 	goto mandos_end;
       }
       /* Set the network interface number as scope */
@@ -675,6 +666,7 @@
   }
   if(ret < 0){
     perror("connect");
+    retval = -1;
     goto mandos_end;
   }
   
@@ -690,6 +682,7 @@
 				   out_size - written));
     if(ret == -1){
       perror("write");
+      retval = -1;
       goto mandos_end;
     }
     written += (size_t)ret;
@@ -735,6 +728,7 @@
       fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
+    retval = -1;
     goto mandos_end;
   }
   
@@ -755,6 +749,7 @@
 				   buffer_capacity);
     if(buffer_capacity == 0){
       perror("incbuffer");
+      retval = -1;
       goto mandos_end;
     }
     
@@ -783,12 +778,14 @@
 	if(ret < 0){
 	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
+	  retval = -1;
 	  goto mandos_end;
 	}
 	break;
       default:
 	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
+	retval = -1;
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	goto mandos_end;
       }
@@ -805,12 +802,11 @@
     goto mandos_end;
   }
   
-  do {
-    ret = gnutls_bye(session, GNUTLS_SHUT_RDWR);
-    if(quit_now){
-      goto mandos_end;
-    }
-  } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
+  gnutls_bye(session, GNUTLS_SHUT_RDWR);
+  
+  if(quit_now){
+    goto mandos_end;
+  }
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
@@ -833,18 +829,22 @@
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
 		    strerror(errno));
 	  }
-	  goto mandos_end;
+	  retval = -1;
+	  break;
 	}
 	written += (size_t)ret;
       }
-      retval = 0;
+      free(decrypted_buffer);
+    } else {
+      retval = -1;
     }
+  } else {
+    retval = -1;
   }
   
   /* Shutdown procedure */
   
  mandos_end:
-  free(decrypted_buffer);
   free(buffer);
   if(tcp_sd >= 0){
     ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
@@ -976,101 +976,6 @@
   errno = old_errno;
 }
 
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror("open");
-    return 0;
-  }
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
-      break;
-    }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
-    if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
-    }
-    free(flagstring);
-    return 0;
-  }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
-  /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
-    if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
-    if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 1;
-  }
-  /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept this device */
-  if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
-  }
-  return 1;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1078,12 +983,13 @@
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  const char *interface = "";
+  const char *interface = "eth0";
   struct ifreq network;
   int sd = -1;
   bool take_down_interface = false;
   uid_t uid;
   gid_t gid;
+  char *connect_to = NULL;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
@@ -1219,31 +1125,6 @@
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-
-  if(interface[0] == '\0'){
-    struct dirent **direntries;
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Pick the first good interface */
-      interface = strdup(direntries[0]->d_name);
-      if(debug){
-	fprintf(stderr, "Using interface \"%s\"\n", interface);
-      }
-      if(interface == NULL){
-	perror("malloc");
-	free(direntries);
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      free(direntries);
-    } else {
-      free(direntries);
-      fprintf(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
   
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
@@ -1320,7 +1201,7 @@
   }
   
   /* If the interface is down, bring it up */
-  if(strcmp(interface, "none") != 0){
+  if(interface[0] != '\0'){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
@@ -1397,7 +1278,7 @@
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
 	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
+	perror("ioctl SIOCSIFFLAGS");
 	exitcode = EXIT_FAILURE;
 #ifdef __linux__
 	if(restore_loglevel){
@@ -1654,7 +1535,7 @@
 	network.ifr_flags &= ~IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
+	  perror("ioctl SIOCSIFFLAGS");
 	}
       }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
@@ -1717,20 +1598,11 @@
   if(quit_now){
     sigemptyset(&old_sigterm_action.sa_mask);
     old_sigterm_action.sa_handler = SIG_DFL;
-    ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
-					    &old_sigterm_action,
-					    NULL));
+    ret = sigaction(signal_received, &old_sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
     }
-    do {
-      ret = raise(signal_received);
-    } while(ret != 0 and errno == EINTR);
-    if(ret != 0){
-      perror("raise");
-      abort();
-    }
-    TEMP_FAILURE_RETRY(pause());
+    raise(signal_received);
   }
   
   return exitcode;

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-08-10 19:08:24 +0000
+++ plugins.d/mandos-client.xml	2009-02-09 02:01:13 +0000
@@ -202,9 +202,8 @@
 	<listitem>
 	  <para>
 	    Network interface that will be brought up and scanned for
-	    Mandos servers to connect to.  The default is the empty
-	    string, which will automatically choose an appropriate
-	    interface.
+	    Mandos servers to connect to.  The default is
+	    <quote><literal>eth0</literal></quote>.
 	  </para>
 	  <para>
 	    If the <option>--connect</option> option is used, this
@@ -221,11 +220,10 @@
 	    by this program.
 	  </para>
 	  <para>
-	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will not use
-	    any specific interface, and will not bring up an interface
-	    on startup.  This is not recommended, and only meant for
-	    advanced users.
+	    <replaceable>NAME</replaceable> can be the empty string;
+	    this will not use any specific interface, and will not
+	    bring up an interface on startup.  This is not
+	    recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2009-09-17 04:16:32 +0000
+++ plugins.d/usplash.c	2009-09-16 23:28:39 +0000
@@ -612,13 +612,11 @@
   }
   
   /* Close FIFO (again) */
-  if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
-    if(ret == -1 and errno != EINTR){
-      perror("close");
-    }
-    fifo_fd = -1;
+  ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
+  if(ret == -1 and errno != EINTR){
+    perror("close");
   }
+  fifo_fd = -1;
   
   if(interrupted_by_signal){
     struct sigaction signal_action = { .sa_handler = SIG_DFL };

